use glommio::io::OpenOptions;

fn main() {
    glommio::LocalExecutor::default().run(async move {
        let file = OpenOptions::new().tmpfile(true).read(true).write(true).dma_open("/tmp/").await.expect("couldn't open file");
        let mut buf = file.alloc_dma_buffer(4096);
        let mut idx = 0usize;
        buf.as_bytes_mut().fill_with(|| {idx += 1; idx as u8});
        file.write_at(buf, 0).await.expect("failed to write buffer");

        let read = file.read_at_aligned(0, 512).await.expect("failed to read buffer");
        let sum = read.iter().map(|&b| b as usize).sum::<usize>();
        assert_eq!(sum, 65280);

        let read = file.read_at_aligned(512, 4096).await.expect("failed to read buffer");
        assert_eq!(read.len(), 3584);
        let sum = read.iter().map(|&b| b as usize).sum::<usize>();
        assert_eq!(sum, 456960);
    });
}
